#property copyright "Copyright 2006, Aaragorn"


//----user inputs

extern double LongEMA = 5;
extern double ShortEMA = 1;
extern double TrailingStop = 5;
extern double TrailingStopTrigger = 1;
extern double StopLoss = 186;
extern double TakeProfit = 250;
extern double Lots = 0.1;
extern double EquityStop = 9;

//---- Channel and Filter Parameters

extern int        Hours=36;
extern color      col=SkyBlue;
extern double     TF  = 60; //--which bar period for the custom indicator to use 
extern double     upperproximity  =  30;  //---disallows long orders within this proximity to resistance line 
extern double     lowerproximity  =  30;  //---disallows short orders within this proximity to the support line
//+------------------------------------------------------------------+
extern int  MinutesToClose = 30;  // minutes after open to check state of trade
extern int  FirstJump      = 5;   // if after that time we don't have +5 pips we will exit
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| 
//+------------------------------------------------------------------+
int start(){
CloseOrder(); 
int cnt, ticket;
if(Bars<100){
Print("bars less than 100");
return(0);
}

double currentlong=iMA(NULL,0,LongEMA,0,MODE_EMA,PRICE_CLOSE,0);//--current period longEMA
double currentshort=iMA(NULL,0,ShortEMA,0,MODE_EMA,PRICE_CLOSE,0);//--current period shortEMA

double previouslong=iMA(NULL,0,LongEMA,0,MODE_EMA,PRICE_CLOSE,1);//--previous period longEMA
double previousshort=iMA(NULL,0,ShortEMA,0,MODE_EMA,PRICE_CLOSE,1);//--previous period shortEMA

double previous2long=iMA(NULL,0,LongEMA,0,MODE_EMA,PRICE_CLOSE,2);//--previous 2period longEMA
double previous2short=iMA(NULL,0,ShortEMA,0,MODE_EMA,PRICE_CLOSE,2);//--previous 2period shortEMA

double previous3long=iMA(NULL,0,LongEMA,0,MODE_EMA,PRICE_CLOSE,3);//--previous 3period longEMA
double previous3short=iMA(NULL,0,ShortEMA,0,MODE_EMA,PRICE_CLOSE,3);//--previous 3period shortEMA

//----------channel filter
  double resistance = iCustom(NULL,TF,"Channel-1",Hours,col,0,0);
double support = iCustom(NULL,TF,"Channel-1",Hours,col,2,0);
//--- end channel filter

int total=OrdersTotal();
if(total<1){
if(AccountFreeMargin()<(1000*Lots)){
Print("We have no money. Free Margin = ", AccountFreeMargin());
return(0);
}

if (previous3short<previous3long && previous2short>previous2long && previousshort>previouslong && Ask > resistance - upperproximity*Point){
ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point, NULL,16384,0,Green);
if(ticket>0){
if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES )) Print("BUY order opened : ",OrderOpenPrice());
}
else Print("Error opening BUY order : ",GetLastError());
return(0);
}

if (previous3short>previous3long && previous2short<previous2long && previousshort<previouslong && Ask < support + lowerproximity*Point){
ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point, NULL,16384,0,Red);
if(ticket>0) {
if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES )) Print("SELL order opened : ",OrderOpenPrice());
}
else Print("Error opening SELL order : ",GetLastError());
return(0);
}
}
for(cnt=0;cnt<total;cnt++) {
OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()) {
if(OrderType()==OP_BUY){
if(TrailingStop>0) {
if(Bid-OrderOpenPrice()>Point*TrailingStopTrigger) {
if(OrderStopLoss()<Bid-Point*TrailingStop) {
OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
return(0);
}
}
}
}else{
if(TrailingStop>0) {
if((OrderOpenPrice()-Ask)>(Point*TrailingStopTrigger)) {
if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0)) {
OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
return(0);
}
}
}
}
if((AccountEquity()+ EquityStop)<AccountBalance()) { 
{
  int ttotal = OrdersTotal();
  for(int i=ttotal-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();

    bool result = false;
    
    switch(type)
    {
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          
    }
    
    if(result == false)
    {
      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(3000);
    }  
  }
  
  return(0);
}
}
}
}
}
  //+------------------------------------------------------------------+
void CloseOrder()
{
   double Profit=FirstJump*Point;
   int total = OrdersTotal();
   for (int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if ((CurTime()-OrderOpenTime())>MinutesToClose*60)
      {
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && Bid-Profit<OrderOpenPrice() )
         {
         OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
         }
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && Bid+Profit>OrderOpenPrice()) 
         {
         OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
         }
      }  
   }
}
//+------------------------------------------------------------------+